
HUDown = HUDown or {}
if not HUDown.setup then
	HUDown.setup = true

	HUDown._path = ModPath
	HUDown._core_path = ModPath .. "Core/"
	HUDown._options_file = SavePath .. "HUDown.json"
	HUDown._options = {}

	function HUDown:Save()
		local file = io.open(self._options_file, "w+")
		if file then
			file:write(json.encode(self._options))
			file:close()
		end
	end

	function HUDown:Load()
		self:LoadDefaults()
		local file = io.open(self._options_file, "r")
		if file then
			local settings = json.decode(file:read("*all"))
			file:close()
			if settings ~= nil and type(settings) == "table" then
				for k, v in pairs(settings) do
					self._options[k] = v
				end
			end
		end
	end

	function HUDown:GetOption(id)
		return self._options[id]
	end

	function HUDown:SetOption(id, value)
		if self._options[id] ~= value then
			self._options[id] = value
			self:OptionChanged()
		end
	end

	function HUDown:OptionChanged()
		self:Save()
		if managers and managers.hud and managers.hud._hud_downhud then
			managers.hud._hud_downhud:update()
		end
	end

	function HUDown:LoadDefaults()
		local default_file = io.open(self._path .. "default_values.json")
		self._options = json.decode(default_file:read("*all"))
		default_file:close()
	end

	function HUDown:Require(fileName)
		dofile(HUDown._core_path .. fileName .. ".lua")
	end

	HUDown:Load()
	MenuHelper:LoadFromJsonFile(HUDown._path .. "Menu/menu.json", HUDown, HUDown._options)
end