HUDown:Require("OutlineText")

DownHUD = DownHUD or class()

function DownHUD:init(hud)
	self._hud_panel = hud.panel

	if self._hud_panel:child("downhud_panel") then
		self._hud_panel:remove(self._hud_panel:child("downhud_panel"))
	end

	self._downhud_panel = self._hud_panel:panel({
		name = "downhud_panel",
		alpha = 0,
		layer = 1
	})
	
	local font = tweak_data.hud_players.name_font

	self._downer_panel = self._downhud_panel:panel()
	self._downer_ftw = self._downer_panel:bitmap({
		name = "downer_ftw",
		w = (HUDown:GetOption("size")),
		h = (HUDown:GetOption("size")),
		blend_mode = "add",
		layer = 2
	})
	self._max_revives = self:_max_revives()
	self._revives = self._max_revives
	self._revives_counter = OutlineText:new(self._downhud_panel, {
		text = (HUDown:GetOption("show_revives_counter_skull") and utf8.char(57364) or "") .. self._revives,
		color = Color.white,
		align = "center",
		vertical = "center",
		font = font,
		font_size = (HUDown:GetOption("size")),
		layer = 3
	})

	self:update()
end

function DownHUD:update()
	local x_offset = HUDown:GetOption("x_offset")
	local y_offset = HUDown:GetOption("y_offset")
	local x_center = self._downhud_panel:w() / 2 + x_offset
	local y_center = self._downhud_panel:h() / 2 + y_offset
	self._downer_ftw:set_center(x_center)
	self._downer_ftw:set_center_y(y_center)
	self._revives_counter:set_top(self._downer_ftw:top())
	self._revives_counter:set_right(self._downer_ftw:right())
	self._revives_counter:set_align("right")
	self._downer_panel:set_alpha(alpha)
	self:_update_health()
	self:_update_revives()
end

function DownHUD:_check_player_state()
	if not managers.player
			or not managers.player:player_unit()
			or not managers.player:player_unit():character_damage() then
		return false
	end
	local state = managers.player:current_state() or "empty"
	return state ~= "bleed_out" and state ~= "fatal" and state ~= "arrested" and state ~= "incapacitated"
end

function DownHUD:update_status()
	self._downhud_panel:set_visible(self:_check_player_state())
end

function DownHUD:update_visbility()
	self._downhud_panel:set_alpha(1)
end

function DownHUD:_update_health()
	self:update_visbility()
end

function DownHUD:set_health(data)
	if data.current > 0 and self:_check_player_state() then
		self._downhud_panel:set_visible(true)
	end
	if data.revives then
		self._revives = data.revives - 1
		self:_update_revives()
	end
end

function DownHUD:_max_revives()
	return managers.modifiers:modify_value("PlayerDamage:GetMaximumLives", (Global.game_settings.difficulty == "sm_wish" and 2 or tweak_data.player.damage.LIVES_INIT) + managers.player:upgrade_value("player", "additional_lives", 0)) - 1
end

function DownHUD:_update_revives()
	self._revives_counter:set_font_size(HUDown:GetOption("size"))
	self._revives_counter:set_text((HUDown:GetOption("show_revives_counter_skull") and utf8.char(57364) or "") .. self._revives)
	self._revives_counter:set_color(math.lerp(Color(1, 1, 0.2, 0), Color.white, math.clamp(self._revives / self._max_revives, 0, 1)))
	self._revives_counter:set_visible(HUDown:GetOption("show_revives_counter"))
	self._revives_counter:set_alpha(HUDown:GetOption("revives_counter_alpha"))
end